Nftables栈溢出漏洞(CVE-2022-1015)复现

2023-07-04 16:45:40

所属地 湖南省

![](https://image.3001.net/images/20240308/1709876354_65eaa4828e91d155430d9.png) 本文由 创作，已纳入「FreeBuf原创奖励计划」，未授权禁止转载

背景介绍

### Nftables

Nftables 是一个基于内核的包过滤框架，用于 Linux操作系统中的网络安全和防火墙功能。nftables的设计目标是提供一种更简单、更灵活和更高效的方式来管理网络数据包的流量。

### **钩子点（Hook Point）**

钩子点的作用是拦截数据包，然后对数据包进行修改，比较，丢弃和放行等操作。

![202307041600426.png](https://image.3001.net/images/20230704/1688460340_64a3dc34d2a4f679e94fc.png)

// include/uapi/linux/netfilter\_ipv4.h  
​  
#define NF\_IP\_PRE\_ROUTING    0 /\* After promisc drops, checksum checks. \*/  
#define NF\_IP\_LOCAL\_IN       1 /\* If the packet is destined for this box. \*/  
#define NF\_IP\_FORWARD        2 /\* If the packet is destined for another interface. \*/  
#define NF\_IP\_LOCAL\_OUT      3 /\* Packets coming from a local process. \*/  
#define NF\_IP\_POST\_ROUTING   4 /\* Packets about to hit the wire. \*/  
#define NF\_IP\_NUMHOOKS       5

### Nftables的架构

Nftables由四部分组成

*   table（表）：用于指定网络协议的类型，如ip，ip6，arp等
    
*   chains（链）：用于指定流量的类型，如流入的流量或者是流出的流量并可以指定网络接口，如本地回环接口或者以太网接口等。
    
*   rules（规则）：规则是用于过滤数据包所依据的规则，例如检查协议、来源、目的地、端口等规则。
    
*   express（表达式）：表达式则是具体的操作。
    

使用非常形象的图描述，如下

![202307041600428.png](https://image.3001.net/images/20230704/1688460342_64a3dc36119a72d9c9555.png)

### 表达式（express）

表达式是对一个数据包具体的操作，这里大致介绍后续需要用到的表达式。

**nft\_payload**

nft\_payload用于将数据包的值拷贝到寄存器中

struct nft\_payload {  
enum nft\_payload\_bases  base:8;  
u8          offset;  
u8          len;  
u8          dreg;  
};

*   base：数据包类型
    
*   offset：数据包起始位置的偏移
    
*   len：拷贝的长度
    
*   dreg：目的寄存器
    

其中base的类型由enum nft\_payload\_bases指定

/\* include/uapi/linux/netfilter/nf\_tables.h \*/  
/\*\*  
\* enum nft\_payload\_bases - nf\_tables payload expression offset bases  
\*  
\* @NFT\_PAYLOAD\_LL\_HEADER: link layer header  
\* @NFT\_PAYLOAD\_NETWORK\_HEADER: network header  
\* @NFT\_PAYLOAD\_TRANSPORT\_HEADER: transport header  
\* @NFT\_PAYLOAD\_INNER\_HEADER: inner header / payload  
\*/  
enum nft\_payload\_bases {  
NFT\_PAYLOAD\_LL\_HEADER, //链路层  
NFT\_PAYLOAD\_NETWORK\_HEADER, //网络层  
NFT\_PAYLOAD\_TRANSPORT\_HEADER, //传输层  
NFT\_PAYLOAD\_INNER\_HEADER, //数据包内部  
};

下面这个例子则是将传输层的包偏移16个字节的位置，取出两个字节的内容存放到目的寄存器中，该寄存器的编号为2

base = NFT\_PAYLOAD\_TRANSPORT\_HEADER  
offset = 16 -> the checksum is 16 bytes away from the start of the TCP header  
len = 2 -> the checksum is 2 bytes  
dreg = NFT\_REG32\_02 (the small registers start frrom NFT\_REG32\_00)

**nft\_payload\_set**

nft\_payload\_set则是与nft\_payload相反，该表达式是将指定寄存器的值存放到数据包里面

/\* include/net/netfilter/nf\_tables\_core.h \*/  
struct nft\_payload\_set {  
enum nft\_payload\_bases  base:8;  
u8          offset;  
u8          len;  
u8          sreg;  
u8          csum\_type;  
u8          csum\_offset;  
u8          csum\_flags;  
};

与nft\_payload不同的是多了校验和的可选选项

【----帮助网安学习，以下所有学习资料免费领！加vx：yj009991，备注“freebuf”获取！】

① 网安学习成长路径思维导图  
② 60+网安经典常用工具包  
③ 100+SRC漏洞分析报告  
④ 150+网安攻防实战技术电子书  
⑤ 最权威CISSP 认证考试指南+题库  
⑥ 超1800页CTF实战技巧手册  
⑦ 最新网安大厂面试题合集（含答案）  
⑧ APP客户端安全检测指南（安卓+IOS）

**nft\_cmp\_expr**

nft\_cmp\_expr表达式则是用于比较，通常用于判断数据包的端口号是否是需要符合要求。

struct nft\_cmp\_expr {  
struct nft\_data     data;  
u8          sreg;  
u8          len;  
enum nft\_cmp\_ops    op:8;  
};

*   data：用于设置比较的常量值
    
*   sreg：源寄存器，可以认为是数据包取出的内容
    
*   len：比较的长度
    
*   op：比较的操作，具体操作类型如下所示
    

<!-- -->

/\*\*  
\* enum nft\_cmp\_ops - nf\_tables relational operator  
\*  
\* @NFT\_CMP\_EQ: equal  
\* @NFT\_CMP\_NEQ: not equal  
\* @NFT\_CMP\_LT: less than  
\* @NFT\_CMP\_LTE: less than or equal to  
\* @NFT\_CMP\_GT: greater than  
\* @NFT\_CMP\_GTE: greater than or equal to  
\*/  
enum nft\_cmp\_ops {  
NFT\_CMP\_EQ,  
NFT\_CMP\_NEQ,  
NFT\_CMP\_LT,  
NFT\_CMP\_LTE,  
NFT\_CMP\_GT,  
NFT\_CMP\_GTE,  
};

**nft\_bitwise**

nft\_bitwise用于对数据包进行比特级别的操作。例如移位，掩码设置等。

struct nft\_bitwise {  
u8          sreg;  
u8          dreg;  
enum nft\_bitwise\_ops    op:8;  
u8          len;  
struct nft\_data     mask;  
struct nft\_data     xor;  
struct nft\_data     data;  
};

*   sreg：源寄存器
    
*   dreg：目的寄存器，用于存放最后的结果
    
*   op：指定具体的比特操作，具体操作如下
    

<!-- -->

/\*\*  
\* enum nft\_bitwise\_ops - nf\_tables bitwise operations  
\*  
\* @NFT\_BITWISE\_BOOL: mask-and-xor operation used to implement NOT, AND, OR and  
\*                    XOR boolean operations  
\* @NFT\_BITWISE\_LSHIFT: left-shift operation  
\* @NFT\_BITWISE\_RSHIFT: right-shift operation  
\*/  
enum nft\_bitwise\_ops {  
NFT\_BITWISE\_BOOL,  
NFT\_BITWISE\_LSHIFT,  
NFT\_BITWISE\_RSHIFT,  
};

*   mask：当op被指定为NFT\_BITWISE\_BOOL时，sreg的值会与mask中指定的值进行掩码设置操作。并将结果存放到dreg中
    
*   xor：当op被指定为NFT\_BITWISE\_BOOL时，sreg的值会与xor中指定的值进行掩码设置操作。并将结果存放到dreg中
    
*   data：当op被指定为NFT\_BITWISE\_LSHIFT或NFT\_BITWISE\_RSHIFT时，data需要被指定移位的数值。
    

### 寄存器（register）

在Nftables中是以寄存器作为存储区，用于存放一段连续的内存，现在Nftables版本每个寄存器的值存放4字节数据，而旧版的Nftables的每个寄存器是存放16个字节的数据，为了保持兼容性，4字节的寄存与16字节的寄存器都被保留。寄存器的枚举值如下所示

enum nft\_registers {  
NFT\_REG\_VERDICT, //判定寄存器  
NFT\_REG\_1,  
NFT\_REG\_2,  
NFT\_REG\_3,  
NFT\_REG\_4,  
\_\_NFT\_REG\_MAX,  
​  
NFT\_REG32\_00    = 8,  
NFT\_REG32\_01,  
NFT\_REG32\_02,  
...  
NFT\_REG32\_13,  
NFT\_REG32\_14,  
NFT\_REG32\_15,  
};

![202307041600429.png](https://image.3001.net/images/20230704/1688460345_64a3dc39103910259028e.png)

其中NFT\_REG\_VERDICT被称之为判断寄存器，这个寄存器比较特殊，是用于判定每个数据包需要怎么处理。判定的类型如下

*   NFT\_CONTINUE：允许数据包通过防火墙
    
*   NFT\_BREAK：跳过剩余的规则表达式
    
*   NF\_DROP：直接丢弃数据包
    
*   NF\_ACCEPT：接收数据包
    
*   NFT\_GOTO：跳转到其他链执行
    
*   NFT\_JUMP：跳转到其他链执行，若其他链将该数据包判定为NFT\_CONTINUE则返回当前链
    

### libmnl与libnftnl

由于Nftables处于内核，需要从用户层向内核发送消息去设置需要拦截数据包的属性，人工构造成本较大，因此使用现成的库libmnl与libnftnl

### 环境搭建

**环境版本**

*   ubuntu 20.04
    
*   qemu-system-x86\_64 4.2.1
    
*   Linux-5.17源码
    

设置编译选项

cd /home/pwn/CVE/CVE-2022-1015/CVE-2022-1015/linux-5.17  
sudo gedit .config  
#将下列选项设置为y  
CONFIG\_NF\_TABLES=y  
CONFIG\_NETFILTER\_NETLINK=y  
CONFIG\_USER\_NS=y  
CONFIG\_E1000=y  
CONFIG\_E1000E=y  
make -j32 bzImage #编译  
​  
#安装依赖库  
sudo apt-get install libmnl-dev   
sudo apt-get install libnftnl-dev

### 漏洞验证

若运行exp显示超过边界则代表没有漏洞

![202307041600431.png](https://image.3001.net/images/20230704/1688460345_64a3dc39ee8873af3ee96.png)

若exp正常运行则代表漏洞

![202307041600432.png](https://image.3001.net/images/20230704/1688460347_64a3dc3b1496376852b80.png)

### 漏洞分析

**源码分析**

**nft\_parse\_register\_load**

nft\_cmp\_expr：op=NFT\_CMP\_EQ sreg=8data=IPPROTO\_TCP。该表达式是一个比较的表达式，用于比较下标为8的寄存器中的数据是否为TCP的协议。那么如何将下表为8的寄存器转化为内核中寄存器的内存位置，则需要以来下面列举的函数。

nft\_parse\_register\_load函数就是将用户设定的寄存器的下标转化为内核寄存器的下标，然后存储在源寄存器中。

File: net\\netfilter\\nf\_tables\_api.c  
9325: int nft\_parse\_register\_load(const struct nlattr \*attr, u8 \*sreg, u32 len)  
9326: {  
9327:   u32 reg;  
9328:   int err;  
9329:   
9330:   reg = nft\_parse\_register(attr); //用于提取数据包中的寄存器的下标，并转化为Nftables中寄存器的下标  
9331:   err = nft\_validate\_register\_load(reg, len); //用于检验寄存器下表的合法性，漏洞点  
9332:   if (err < 0)  
9333:       return err;  
9334:   
9335:   \*sreg = reg; //然后将寄存器的下标值存储在源寄存器中  
9336:   return 0;  
9337: }

**nft\_parse\_register**

nft\_parse\_register函数用于将用户设置的寄存器下标转化为内核中寄存器的下标。

File: net\\netfilter\\nf\_tables\_api.c  
9278: static unsigned int nft\_parse\_register(const struct nlattr \*attr)  
9279: {  
9280:   unsigned int reg;  
9281:   
9282:   reg = ntohl(nla\_get\_be32(attr)); //提取数据包的寄存器下标，比如上述例子为8  
9283:   switch (reg) {  
//0 - 4是16字节寄存器  
9284:   case NFT\_REG\_VERDICT...NFT\_REG\_4:   
9285:       return reg \* NFT\_REG\_SIZE / NFT\_REG32\_SIZE;  //reg \* 4  
9286:   default:  
//由于4字节寄存器起始下标为8，因此要减去起始下标  
9287:       return reg + NFT\_REG\_SIZE / NFT\_REG32\_SIZE - NFT\_REG32\_00; // reg  - 4  
9288:   }  
9289: }

**nft\_validate\_register\_load**

nft\_validate\_register\_load函数则是用于校验下标是否有问题，但是这个检验存在整型溢出的问题。reg是枚举值，而枚举通常会被编译为int类型。len代表数据包的长度。

*   正常情况下：reg = 100，那么套入校验则为100 \* 4 + 0x10 = 0x1a0 >0x50，那么会检验出寄存器下标存在问题
    
*   漏洞情况：reg =0xffffffff（int情况下的最大值），那么逃入检验则为0xffffffff \* 4 +0x10 =0x40000000c，由于int最大值为0xffffffff，那么最高4个比特会被舍弃，那么最后得到的值为0x0000000c，此时0xc< 0x50，就可以绕过检验。那么绕过检验后就会执行\* sreg =reg，此时reg = 0xffffffff，就会导致\*sreg = 0xff
    

<!-- -->

File: net\\netfilter\\nf\_tables\_api.c  
9313: static int nft\_validate\_register\_load(enum nft\_registers reg, unsigned int len)  
9314: {  
9315:   if (reg < NFT\_REG\_1 \* NFT\_REG\_SIZE / NFT\_REG32\_SIZE) // reg < 4则报错  
9316:       return -EINVAL;  
9317:   if (len == 0) //长度为0则报错  
9318:       return -EINVAL;  
9319:   if (reg \* NFT\_REG32\_SIZE + len > sizeof\_field(struct nft\_regs, data)) //reg \* 4 + len > 0x50则报错，存在整型溢出漏洞  
9320:       return -ERANGE;  
9321:   
9322:   return 0;  
9323: }

**nft\_do\_chain**

每一个被拦截的数据包都需要经过链上的表达式进行处理，而链处理的函数则为nft\_do\_chains，这个函数会提取出相应的表达式，最后调用expr\_call\_ops\_eval函数进行处理。

File: net\\netfilter\\nf\_tables\_core.c  
197: unsigned int  
198: nft\_do\_chain(struct nft\_pktinfo \*pkt, void \*priv)  
199: {  
...  
224:    for (; rule < last\_rule; rule = nft\_rule\_next(rule)) {  
225:        nft\_rule\_dp\_for\_each\_expr(expr, last, rule) {  
226:            if (expr->ops == &nft\_cmp\_fast\_ops)  
227:                nft\_cmp\_fast\_eval(expr, &regs);  
228:            else if (expr->ops == &nft\_bitwise\_fast\_ops)  
229:                nft\_bitwise\_fast\_eval(expr, &regs);  
230:            else if (expr->ops != &nft\_payload\_fast\_ops ||  
231:                 !nft\_payload\_fast\_eval(expr, &regs, pkt))  
232:                expr\_call\_ops\_eval(expr, &regs, pkt);  
233:   
234:            if (regs.verdict.code != NFT\_CONTINUE)  
235:                break;  
236:        }  
...

**expr\_call\_ops\_eval**

expr\_call\_ops\_eval函数则是根据不同的表达式选择不同的处理函数，例如若该数据包需要经过nft\_payload的表达式处理，则会调用nft\_payload\_eval。

File: net\\netfilter\\nf\_tables\_core.c  
161: static void expr\_call\_ops\_eval(const struct nft\_expr \*expr,  
162:                   struct nft\_regs \*regs,  
163:                   struct nft\_pktinfo \*pkt)  
164: {  
165: #ifdef CONFIG\_RETPOLINE  
166:    unsigned long e = (unsigned long)expr->ops->eval;  
167: #define X(e, fun) \\  
168:    do { if ((e) == (unsigned long)(fun)) \\  
169:        return fun(expr, regs, pkt); } while (0)  
170:   
171:    X(e, nft\_payload\_eval);  
172:    X(e, nft\_cmp\_eval);  
173:    X(e, nft\_counter\_eval);  
174:    X(e, nft\_meta\_get\_eval);  
175:    X(e, nft\_lookup\_eval);  
176:    X(e, nft\_range\_eval);  
177:    X(e, nft\_immediate\_eval);  
178:    X(e, nft\_byteorder\_eval);  
179:    X(e, nft\_dynset\_eval);  
180:    X(e, nft\_rt\_get\_eval);  
181:    X(e, nft\_bitwise\_eval);  
182: #undef  X  
183: #endif /\* CONFIG\_RETPOLINE \*/  
184:    expr->ops->eval(expr, regs, pkt);  
185: }

**nft\_payload\_eval**

这里可以看到regs存放在栈上面，dest这个变量值是通过&regs->data\[priv->dreg\]取出来的，而priv->dreg则是通过上述的nft\_parse\_register\_load函数进行提取的，那么这里就存在一个非常明显的数组越界的漏洞。

File: net\\netfilter\\nft\_payload.c  
121: void nft\_payload\_eval(const struct nft\_expr \*expr,  
122:              struct nft\_regs \*regs,  
123:              const struct nft\_pktinfo \*pkt)  
124: {  
125:    const struct nft\_payload \*priv = nft\_expr\_priv(expr);  
126:    const struct sk\_buff \*skb = pkt->skb;  
127:    u32 \*dest = &regs->data\[priv->dreg\];  
...  
165:    if (skb\_copy\_bits(skb, offset, dest, priv->len) < 0) //拷贝数据  
166:        goto err;  
167:    return;  
168: err:  
169:    regs->verdict.code = NFT\_BREAK;  
170: }

因此整型溢出结合越界就能够使我们访问到内核栈上的其他数据，如下图所示。

![202307041600433.png](https://image.3001.net/images/20230704/1688460348_64a3dc3c5835780573956.png)

### 漏洞利用

**漏洞利用分析**

现在我们拥有了访问内核栈上其它地址的能力了，想要做到任意代码执行则需要考虑下列几种情况

*   由于返回地址存在在栈上，需要判断数组越界是否能够到达返回地址的位置
    
*   如何通过数组越界改写返回地址
    
*   由于需要进行任意代码执行，那么需要用到内核函数，则需要得到内核的程序基地址才能够根据函数偏移地址计算出函数的实际地址
    

由于表达式都会对寄存器空间进行操作，因此可以使用表达式对内存空间进行读写操作。

nft\_bitwise表达式可以控制源寄存器和目的寄存器，那么采用nft\_bitwise可以将源寄存器的内容放置到目的寄存器中，因此可以利用nft\_bitwise进行越界读，此时需要分析该数组越界读的边界的大小是多少。这里需要注意的是由于len是sreg与dreg共同拥有的，为了dreg不越界，这里的长度最大值只能为0x40而不能为0xff，因为拥有16个寄存器，每个寄存器的值为4个字节，因此16\* 4 = 64 = 0x40

*   上界：(0xffffffff \* 4) + 0x40 = 0x40000003c = 0x3c < 0x50 ， 0xff\* 4 = 0x3fc；由于可以拷贝0x40个字节的长度，因此0x3fc + 0x40 =0x43c。
    
*   下界：(0xfffffff0 \* 4 ) + 0x40 = 0x400000000 = 0x0 < 0x50, 0xf0 \*4 = 0x3c0
    

**内核地址泄露**

接着查看regs偏移0x3c0处的地址信息，结果发现在该片区域存在一个明显的内核地址，因此若能将这个地址进行泄露，我们就能获取内核的基地址。

![202307041600434.png](https://image.3001.net/images/20230704/1688460349_64a3dc3d5ddff524f1d33.png)

**返回地址覆盖**

由于需要构建的payload比较长，而我们如果利用nft\_wise最多只能写入0x43c -0x3c0 =0x7c的长度，是远远不够的，因此对返回地址进行覆盖时不能使用nft\_bitwise，而得改用nft\_payload。nft\_payload需要dreg的下标以及修改的长度len，由于我们只需要考虑一个寄存器的值，因此该寄存器的长度最大可以达到0xff。因此我们可以在地址更低的位置去搜索有无可以覆盖的返回地址。

可以发现在0x360的地址处也有一个内核的代码段地址

![202307041600435.png](https://image.3001.net/images/20230704/1688460350_64a3dc3ed4148aad64cad.png)

并且可以发现该函数主要是处理udp包的发送

![202307041600436.png](https://image.3001.net/images/20230704/1688460352_64a3dc40c934ee7daa2bc.png)

为了检验该地址是否能够修改程序的执行流程，可以使用一个方法，将该地址的值修改为非法值并观察内核是否会崩溃，这里将地址的内容修改为0x1122334455667788，接着运行程序。

![202307041600437.png](https://image.3001.net/images/20230704/1688460354_64a3dc421c39aa386a1a6.png)

可以看到内核报错的信息显示RIP的地址为刚刚我们修改的地址，因此该地址可以作为被劫持程序执行流程的地址。

![202307041600438.png](https://image.3001.net/images/20230704/1688460355_64a3dc436bdb2011207dd.png)

**exp分析**

现在我们已经具有了两个利用条件

*   泄露内核的程序基地址
    
*   找到可以劫持程序执行流程的地址值
    

**地址泄露**

利用nft\_bitwise泄露地址，这里注意的是在使用nft\_bitwise泄露地址时，需要将data值设置为0，这样就不会进行移位而导致我们的内核地址被修改存储，最后将泄露的地址值放置在NFT\_REG32\_05下标的寄存器中

![202307041600439.png](https://image.3001.net/images/20230704/1688460356_64a3dc44cf52b71ba516e.png)

接着使用nft\_set\_payload将udp数据包的值修改为NFT\_REG32\_05寄存器的值，最后取出udp数据包的值，获取内核程序地址值

![202307041600440.png](https://image.3001.net/images/20230704/1688460358_64a3dc460d9633832fa6b.png)

**返回地址覆盖**

利用nft\_payload完成返回地址的覆盖

![202307041600441.png](https://image.3001.net/images/20230704/1688460359_64a3dc4725eec6793368d.png)

在数据包中将payload填充进去，这里需要说明一下如何在内核中拿到shell权限

*   首先需要在内核中拿到root权限，需要调用commit\_creds(prepare\_kernel\_cred(0))的内核函数获取新的凭证结构，而该结构的uid = 0 ，gid =0即为root权限
    
*   其次需要切换命名空间，由于在普通用户下是无法直接调用Nftables的，因为需要管理员的权限，因此在普通用户下需要新开辟一个命名空间，使得该空间与正常的空间隔离，此时才能够正常执行Nftales。那么如果逃逸这段命名空间则需要进行命名空间的切换，则依赖于switch\_task\_namespace函数，可以将命名空间切换为root的命名空间
    
*   最后则是实现从内核态切换到用户态，由于我们是在内核空间拿到权限，而我们需要在用户态执行，因此需要完成状态的转换，该状态转换依赖于swapgs\_restore\_regs函数
    

![202307041600442.png](https://image.3001.net/images/20230704/1688460360_64a3dc48559cda4e3f923.png)

### 漏洞修复

补丁则是新增一条判断条件，属于4字节寄存器的下标单独处理，而不在16字节寄存器以及4字节寄存器的范围内的下标都进行报错处理

![202307041600443.png](https://image.3001.net/images/20230704/1688460361_64a3dc49dca20b335d917.png)

总结
--

Nftables栈溢出漏洞**攻击流程**

*   首先利用nft\_bitwise进行内核基地址的泄露。
    
*   其次是利用nft\_payload改写返回地址，并将提权代码注入进去。
    
*   最后等到代码被触发。
    

Nftables栈溢出漏洞**利用的限制**

*   不同的内核版本的内核栈布局几乎不同，因此不同版本之间的利用手法相差较大，因此漏洞的利用十分依赖于内核版本，针对不同的版本需要做出针对性的漏洞利用的exp编写。差别存在于内核栈中存在的内核代码段地址的偏移不同，例如有些内核代码段地址偏移距离regs太大，导致无法利用漏洞进行泄露或者改写。

### **更多网安技能的在线实操练习，[请点击这里>>](https://www.hetianlab.com/)**﻿

\# linux \# 栈溢出 \# 漏洞复现